<template>
  <div ref="chartRef" :style="{ height, width }"></div>
</template>
<script>
import { ref, reactive, watch, watchEffect } from 'vue';
import { cloneDeep } from 'lodash';
import { useEcharts } from '@/hooks/useEcharts';

export default {
  name: 'customEchartWaterDroplet',
  props: {
    chartData: {
      type: Array,
      default: () => [],
    },
    size: {
      type: Object,
      default: () => {},
    },
    option: {
      type: Object,
      default: () => ({}),
    },
    width: {
      type: String,
      default: '100%',
    },
    height: {
      type: String,
      default: 'calc(100vh - 78px)',
    },
  },
  emits: ['click'],
  setup(props, { emit }) {
    const chartRef = ref(null);
    const { setOptions, getInstance, resize } = useEcharts(chartRef);
    const option = reactive({
      tooltip: {
        formatter: '{b} ({c})',
      },
      series: [
        {
          type: 'pie',
          radius: '72%',
          center: ['50%', '55%'],
          data: [],
          labelLine: { show: true },
          label: {
            show: true,
            formatter: '{b} \n ({d}%)',
            color: '#B1B9D3',
          },
        },
      ],
    });

    watchEffect(() => {
      props.chartData && initCharts();
    });

    watch(
      () => props.size,
      () => {
        resize();
      },
      {
        immediate: true,
      }
    );

    function initCharts() {
      if (props.option) {
        Object.assign(option, cloneDeep(props.option));
      }
      setOptions(props.option);
      resize();
      getInstance()?.off('click', onClick);
      getInstance()?.on('click', onClick);
    }

    function onClick(params) {
      emit('click', params);
    }

    return { chartRef };
  },
};
</script>
